# PFotos 1.4 Copyright(C) 2017-2021 Cora Kohlmeier, Frank Hamberg
proc timeFilter {input} {
global tf_status tf_start tf_end maxtime mintime min_validtime excludenotime
global csvsep

#if ![info exist tf_start] {set tf_start $mintime}
#if ![info exist tf_end] {set tf_end $maxtime}
set abstime [lindex [split $input $csvsep] 10]
set check 1

if {($abstime < $tf_start || $abstime > $tf_end) && $tf_status==1} {set check 0}	
if {$abstime < $min_validtime && $excludenotime==1} {set check 0}	
#puts "tf_start:$tf_start # abstime:$abstime # min_validtime:$min_validtime:# tf_status:$tf_status # excludenotime:$excludenotime # check:$check"
return $check
}

proc dirFilter {input} {
global excludedirlist excludedirs
set check 1
if {$excludedirlist == 1} {
	set path [file dirname $input] 
	foreach dir $excludedirs {
		if [string match "*$dir*" $path] {set check 0}
#		puts "dirFilter: $path vs $dir --> $check"
	}
}
return $check
}

proc fileFilter {input} {
global excludefilelist excludefiles
set check 1
if {$excludefilelist == 1} {
	set name [file rootname $input] 
	foreach file $excludefiles {
		if [string match "*$file*" $name] {set check 0}
#		puts "fileFilter: $name vs $file --> $check"
	}
}
return $check
}

proc eval_bin {binlist input1 input2} {
 global filterlist
 set check 1
# Möglichst viele Umwandlungen ausserhalb der Schleifen ausführen
 set length [expr [llength $binlist] -1]
 set value [expr 1.0*$input1]
# nicht numerische Spezialfälle abfangen
 if {$input2==""} {set input2 "-"}
 if {[checkUnknown $input2]} {set datavalue $input2} else {set datavalue [expr 1.0*$input2];}
#Nullten Bin überprüfen; hier muss alles rein, was kleiner ist
set test [expr 1.0*[lindex $binlist 0]]
if {($value == $test) && ($datavalue <= $test)} {
#puts "eval_bin--bin0: test:$test datavalue:$datavalue input2:$input2"
	set check 0
	return 0 } 

#Innerhalb der Bins schauen
 for {set i 1} {$i<=$length} {incr i} {
	 set test [expr 1.0*[lindex $binlist [expr $i]]]
#puts "eval_bin--i:$i binlist($i) [lindex $binlist [expr $i]]:$test value:$value input2:$input2 binlist($i+1):[lindex $binlist [expr $i+1]]" 
     if {($value == $test)} {
#		 puts "check1: i=$i +++ value:$input1 -- test:$test --- datavalue:$input2 --- binlist([expr $i]):[lindex $binlist [expr $i]]"
		  if { ($datavalue > [expr 1.0*[lindex $binlist [expr $i-1]]]) && ($datavalue <= $test) } {
     		  set check 0
		  }
     }
 }  

#Letzten Bin überprüfen
set test [expr 1.0*[lindex $binlist end]]
if { ($value == $test) && ($datavalue >= $test) } { set check 0 }

return $check
}

proc check_filter {input} {
global widgetindex widgetlist
global biniso binflash binaperture binfocallength binfocallength35 binexposure binlens bincamera bintimeslot
global filterlist csvsep
set check 1
set multi 1
   set data [split $input $csvsep]
   foreach filter $filterlist {
	   set temp [split $filter "#"]
	   set type [lindex $temp 0]
	   set binvalue [lindex $temp 1]
	   set index $widgetindex($type)
# Sonderfall 1 imgtype --> steht in Feld 11 des in makeselection erzeugten Datensatzes
       if {$index == 9} {set index 11}	   
       set data_value [lindex $data $index]
#   puts "$filter %%% [lindex $data $index] §§ [lindex $temp 1]"

# Sonderfall 2 hourofday --> steht in Feld 12 des in makeselection erzeugten Datensatzes
       if {$index == 10} {set index 12}	   
       set data_value [lindex $data $index]
#   puts "$filter %%% [lindex $data $index] §§ [lindex $temp 1]"
       
	   # Sonderbehandlung Objektive wegen eckiger Klammern in der Bezeichnung	
	   if {$index==2} {
	       set data_value [extractLens [lindex $data $index]]  
	   } 
	   # Sonderbehandlung 35mm äquivalente Brennweite	
	   if {$index==3} {
	       set data_value [extract35mmEquiv [lindex $data $index]]  
	   } 
	   # Sonderbehandlung Brennweite in mm	
	   if {$index==8} {
	       set data_value [extractmm [lindex $data $index]]  
	   } 
  	   # Sonderbehandlung Exif-Info für Blitz	
	   if {$index==7} {
    	   set data_value [extractFlash [lindex $data $index]]
	   } 
 
	   switch $index {
		   1 -
		   2 -
		   7 -
		   11 {if [string match $data_value $binvalue] {set check 0} }
		   12 {set multi [eval_bin $bintimeslot $binvalue $data_value] }
		   3 {set multi [eval_bin $binfocallength35 $binvalue $data_value] }
		   8 {set multi [eval_bin $binfocallength $binvalue $data_value] }
		   4 {set multi [eval_bin $binaperture $binvalue $data_value] }
		   5 {set multi [eval_bin $biniso $binvalue $data_value] }
		   6 {set multi [eval_bin $binexposure $binvalue $data_value] }
  
       }    
       if {$multi==0} {set check 0}
  }
#if {$check==1} {puts "check_filter: input:$input"}

  return $check 
} 
 
