# PFotos 1.4 Copyright(C) 2017-2021 Cora Kohlmeier, Frank Hamberg
proc ExifSearch {searchWin win} {
global searchString MarkAllOn
global bg abg fg bfg tf bfs fs dfg gap warn
global langstring lang
global _searchWin _win
set _searchWin $searchWin
set _win $win

  $win tag configure found -background $warn
  $win tag lower found sel

  grid\
    [entry $searchWin.searchText\
       -textvariable searchString -font "-size $fs" ]\
    [button $searchWin.search\
       -text $langstring(search,$lang)\
       -font "-size $fs" -bg $bg -fg $bfg\
       -command [subst {
        searchExif $win
        $win see insert

        focus $win
      }]]\
    [button $searchWin.mark\
       -text $langstring(markall,$lang)\
       -font "-size $fs" -bg $bg -fg $bfg\
    -command [subst {
      markAll $win
      focus $win
    }]]\
    -sticky news
  grid columnconfigure $searchWin 0 -weight 1

  #
  bind $searchWin.searchText <Return> "[list $searchWin.search invoke]; [list focus $searchWin.searchText]"
# dies ist nicht sauber programmiert, muss aber so bleiben, bis eine Lösung gefunden ist im Binding die Variable $searchWin aufzulösen	                                    
  bind $searchWin.searchText <ButtonRelease-1> {if {$MarkAllOn==1} {markAll $_win}; 
																	focus $_searchWin.searchText}
  #
  #focus $searchWin.searchText
}

proc escape str {
  string map [list \" \\\" \\ \\\\ \[ \\\[ \] \\\] \$ \\\$] $str
}

proc searchExif {win} {
global searchString startPos
  	
  set str [string map [list \" \\\" \\ \\\\] $searchString]
  if {$str eq ""} then {
    $win tag remove sel 1.0 end
    return no
  }
  set found 0
  if {![info exists startPos]} then {
    set startPos 1.0
   }
  if {"-forwards" == "-forwards"} then {
    set searchRange [list $startPos end-1chars]
  } else {
    set searchRange [list insert-1chars 1.0]
  }
 
  set index [eval "$win search\
                           -forwards -regexp \
                           -count found --\
                           \"[escape $searchString]\"\
                           $searchRange"]
  # set index [$win search -- $str insert end]

  if {$index ne ""} then {
    $win tag remove sel 1.0 end
    $win tag add sel $index $index+${found}chars

    if {"-forwards" == "-forwards"} then {
      set line [lindex [split $index "."] 0]
      set row [lindex [split $index "."] 1]
      set startPos  $line.[expr $row+$found-1]
      $win mark set insert sel.last
    } else {
      $win mark set insert sel.first
    }
#	puts "index:$index startPos:$startPos found:$found" 
    return yes
  } else {
    set startPos 1.0
    $win tag remove sel 1.0 end
    return no
  }
}

proc markAll {win} {
global searchString startPos warn bg bfg
global _searchWin _win MarkAllOn

  if ![info exist startPos] {set startPos 1.0}
  $win tag remove found 1.0 end
  set startPosrem $startPos
  if {$searchString eq ""} {return}
  if {$MarkAllOn==1} then {set MarkAllOn 0;$_searchWin.mark configure -foreground $bfg -background $bg; return}
  set MarkAllOn 1
  $_searchWin.mark configure -foreground $bg -background $bfg
  set startPos 1.0
  set index [$win index insert]
  set range [$win tag ranges sel]
  $win mark set insert 1.0
  while {[searchExif $win]} {
    $win tag add found sel.first sel.last
  }
  $win tag remove sel 1.0 end
  if {$range ne ""} then {
    eval $win tag add sel $range
  }
  $win mark set insert $index
  set startPos $startPosrem
}
