# PFotos 1.4 Copyright(C) 2017-2021 Cora Kohlmeier, Frank Hamberg
proc extractExifs {{filelist ""}} {
package require fileutil 
global pfotoshome iconpath datahome dataname home filedir exiftool 
global csvsep DOS cmdstate finalpos batchmode
global langstring lang
set exifformat $pfotoshome/info/exifformat.txt

if { [llength $filelist]==0 } {
  set sourcedir [dirselect $langstring(seldir,$lang) $home]
  if {$sourcedir==""} {return;}
  set exifdataname $datahome/[file tail $sourcedir].csv
  set batchmode 0
} else {
#  set exifdataname $datahome/[clock format [clock seconds] -format "%Y%m%d%H%M%S"].csv
  set exifdataname $datahome/pfotostmp.csv
  set batchmode 1
}  
set dataname $exifdataname
if {$batchmode==0} {
  # eventuelles offenes Fenster schließen
  closeSelection
  # Fenster erzeugen
  set logwin [toolLog]
}
  
# Header schreiben
set wid [open "$exifdataname" w]
puts $wid "Bilddatei$csvsep Kameramodell$csvsep Linse$csvsep Brennweite (35mm)$csvsep Blende$csvsep ISO$csvsep Belichtung$csvsep Blitz$csvsep Brennweite$csvsep Aufnahmedatum"
close $wid

set cmdstate 0
set finalpos end
if {$DOS==1} {
   set formatfile [file nativename $exifformat]
   set datafile [file nativename $exifdataname]

   if {$batchmode==0} {
      set srcdir [file nativename $sourcedir]
      set command [file nativename $pfotoshome/bat/extractallexifs.bat]
      catch [exec {*}[auto_execok $command] $exiftool $formatfile $srcdir $datafile] result
      showFile $datafile
      reRead $dataname
      .lw.but.ok configure -state normal
   } else {
# hier nun die Liste der Argumente Windows-gerecht aufbereiten
# da die Übergabe von aufbereiteten Listen in Windows-Batch-Skripte nicht vernünftig funktioniert (besonders, wenn Pfade Leerzeichen enthalten), 
# wird das komplette Script als Batch-Datei zu erzeugen	   
     set command [file nativename $home/extractselectedexifs.bat]
     set wid [open "$command" w]     
     puts -nonewline $wid "$exiftool -S -m -q -q -f -csv -r -p $formatfile "

     for {set i 0} {$i < [expr [llength $filelist]+0]} {incr i} {
        puts -nonewline $wid "\"[lindex $filelist $i]\" "
     }
     puts $wid "1>>$datafile"
     close $wid
#     append mylist " " [lindex $filelist [llength $filelist]]
     catch [exec {*}[auto_execok $command]] result
     file delete $command
   }      

} else {
   if {$batchmode==0} { 
     set sourcedir [maskSpace $sourcedir]
     set command "$exiftool -S -m -q -q -f -csv -p $exifformat -r $sourcedir | tee -a [maskSpace $exifdataname]"
     Run $command
   } else {
	 if [file isdirectory [lindex $filelist 0]] {set mylist $filelist} else {set mylist [linsert $filelist 0 [lindex $filelist 0]]} 
#     set mylist [maskSpace $mylist]
#     puts $mylist
     set command "exec $exiftool -S -m -q -q -f -csv -p [maskSpace $exifformat] -r $mylist > [maskSpace $exifdataname]"
	 catch $command result
   }	      
}

if {$batchmode==0} {
   # auf das Ende des Ausgabevorgangs von $command warten und dann den OK-Button freischalten.
   vwait cmdstate
   reRead $dataname
   .lw.but.ok configure -state normal
   .lw.scrw.sf yview moveto 1.0   
  }
}
