# PFotos 1.4 Copyright(C) 2017-2021 Cora Kohlmeier, Frank Hamberg
proc InfoFrame {cc} {
global bg fg bfg bfs fs gap sc cbbg
global dataname imagenumber env_ok
global disp_imagenumber disp_selection 
global disp_timeinterval timeboxslider1 timeboxslider2
global langstring lang
global tf_start tf_end tf_status
global maxtime mintime min_validtime actperiod excludenotime excludedirlist excludefilelist excludetypelist
global histcanvas canvaslength canvasheight histsize
# dafür sorgen, dass die Slider im Urzustand auf den Datensatz nitialisiert werden
if {$tf_status==0} {
	set tf_start $min_validtime
    set tf_end $maxtime
}
set actperiod "[timetoDate $tf_start] - [timetoDate $tf_end]"

frame $cc.1 -bg $bg 
#pack $cc.1  -fill x -padx 15
grid $cc.1 -row 0 -column 0 -sticky w
label $cc.1.l -anchor w -width 20 -text $langstring(file,$lang) -font "-size $fs" -bg $bg -fg $fg
label $cc.1.e -anchor w  -textvariable dataname -font "-size $fs" -bg $bg -fg $fg
#pack $cc.1.l $cc.1.e  -side left
grid $cc.1.l -row 0 -column 0 -sticky w
grid $cc.1.e -row 0 -column 1 -sticky w


frame $cc.2 -bg $bg 
#pack $cc.2  -fill x -padx 15
grid $cc.2 -row 1 -column 0 -sticky w

label $cc.2.l -anchor w -width 20 -text $langstring(number,$lang) -font "-size $fs" -bg $bg -fg $fg
set disp_imagenumber [label $cc.2.e  -anchor w -text imagenumber  -font "-size $fs" -bg $bg -fg $fg]
#pack $cc.2.l $cc.2.e  -side left
grid $cc.2.l -row 0 -column 0 -sticky w
grid $cc.2.e -row 0 -column 1 -sticky w


frame $cc.2b -bg $bg 
#pack $cc.2b  -fill x -padx 15
grid $cc.2b -row 2 -column 0 -sticky w

label $cc.2b.l -anchor w -width 20 -text $langstring(period,$lang) -font "-size $fs" -bg $bg -fg $fg
set disp_timeinterval [label $cc.2b.e  -anchor w -textvariable actperiod  -font "-size $fs" -bg $bg -fg $fg]
#pack $cc.2b.l $cc.2b.e  -side left
grid $cc.2b.l -row 0 -column 0 -sticky sw -pady $fs
grid $cc.2b.e -row 0 -column 1 -sticky w

set disp_selection [button $cc.2b.show -text $langstring(show,$lang) -font "-size $fs" -bg $bg -fg $bfg -command { switchSelection }]
	
#pack $cc.3.show -side left 
set dist [expr [winfo reqwidth .top] - [winfo reqwidth $cc.2b.l] - 2*[winfo reqwidth $cc.2b.e]]
grid $cc.2b.show -row 0 -column 1 -sticky ne -padx "$dist 0"

set store_selection [button $cc.2b.store -text $langstring(saveselection,$lang) -font "-size $fs" -bg $bg -fg $bfg -command { export_selection;restoreHist}]
#pack $cc.3.show -side left 
set dist [expr [winfo reqwidth .top] - [winfo reqwidth $cc.2b.l] - 2*[winfo reqwidth $cc.2b.e]]
grid $cc.2b.store -row 1 -column 1 -sticky ne -padx "$dist 0" -pady "0 $fs"

frame $cc.3 -bg $bg
checkbutton $cc.3.cb1  -variable excludenotime -text "" -command [list toggleValidTime] -font "-size $fs" -bg $bg -fg $cbbg -highlightthickness 0
label $cc.3.l1 -anchor w -width [string length $langstring(hidetime,$lang)] -text $langstring(hidetime,$lang) -font "-size $fs" -bg $bg -fg $fg
set dist [expr [winfo reqwidth .top] - [winfo reqwidth $cc.3.l1] ]  
          
grid $cc.3 -row 5 -column 0 -sticky sw -pady "5 0"
grid $cc.3.l1 -row 1 -column 0 -sticky sw
grid $cc.3.cb1 -row 1 -column 1 -sticky se 

checkbutton $cc.3.cb2  -variable excludedirlist -text "" -command [list toggleExcludeLists dir] -font "-size $fs" -bg $bg -fg $cbbg -highlightthickness 0
label $cc.3.l2 -anchor w -width [string length $langstring(excludedirlist,$lang)] -text $langstring(excludedirlist,$lang) -font "-size $fs" -bg $bg -fg $fg
set dist [expr [winfo reqwidth .top] - [winfo reqwidth $cc.3.l2] ]  
          
grid $cc.3.l2 -row 2 -column 0 -sticky sw
grid $cc.3.cb2 -row 2 -column 1 -sticky se 

checkbutton $cc.3.cb3  -variable excludefilelist -text "" -command [list toggleExcludeLists files] -font "-size $fs" -bg $bg -fg $cbbg -highlightthickness 0
label $cc.3.l3 -anchor w -width [string length $langstring(excludefilelist,$lang)] -text $langstring(excludefilelist,$lang) -font "-size $fs" -bg $bg -fg $fg
set dist [expr [winfo reqwidth .top] - [winfo reqwidth $cc.3.l3] ]  
          
grid $cc.3.l3 -row 3 -column 0 -sticky sw
grid $cc.3.cb3 -row 3 -column 1 -sticky se 

checkbutton $cc.3.cb4  -variable excludetypelist -text "" -command [list toggleExcludeLists type] -font "-size $fs" -bg $bg -fg $cbbg -highlightthickness 0
label $cc.3.l4 -anchor w -width [string length $langstring(excludetypes,$lang)] -text $langstring(excludetypes,$lang) -font "-size $fs" -bg $bg -fg $fg
set dist [expr [winfo reqwidth .top] - [winfo reqwidth $cc.3.l3] ]  
          
grid $cc.3.l4 -row 4 -column 0 -sticky sw
grid $cc.3.cb4 -row 4 -column 1 -sticky se 


#Weiterer Button am linken Rand showList liegt in PFOTOS-Stuff
#image create photo .cow -format GIF -file $pfotoshome/test.gif
#set show_struct [button $cc.3.showstruc -text "Verzeichnisse anzeigen" -image .cow -compound top -font "-size $fs" -bg $bg -fg $bfg -command { showList}]
#grid $cc.3.showstruc -row 5 -column 0 -sticky nw -padx "0 0" -pady "5 $fs"

frame $cc.6 -bg $bg 
#pack $cc.4 -fill x -padx 15 -pady $gap
grid $cc.6 -row 4 -column 0 -sticky w -pady $gap

# Werte der Slider berechnen
set interval [expr $maxtime -$mintime]
set sliderincr 1
set sliderincr $interval
set tickinterval [max $sliderincr 1]


set spacer [string length "$langstring(start,$lang)-----"]
# Frame für Canvas für das Zeithistogramm

frame $cc.6.histo -bg $bg
grid $cc.6.histo -row 0 -column 1 -sticky w -ipadx 0
label $cc.6.histo.label -font "-size $fs" -anchor nw -width $spacer -bg $bg -fg $fg -text $langstring(histogram,$lang)
set canvaslength [expr [winfo reqwidth .top] - [winfo reqwidth $cc.6.histo.label] -16*$fs ]
set canvasheight [expr $histsize*$fs]
set histcanvas [frame $cc.6.histo.canvas -width $canvaslength -height $canvasheight -bg $bg]
grid $cc.6.histo.label -row 1 -column 0 -sticky sw
grid $cc.6.histo.canvas -row 1 -column 1 -sticky w

# Frame für den Slider Gesamtzeitraum oben
frame $cc.6.slider1 -bg $bg
grid $cc.6.slider1 -row 1 -column 1 -sticky w

label $cc.6.slider1.label -font "-size $fs" -anchor nw -width $spacer -bg $bg -fg $fg -text $langstring(start,$lang)
# Geometrie der Slider berechnen
set slidlength [expr [winfo reqwidth .top] - [winfo reqwidth $cc.6.slider1.label] -16*$fs ]
set resolution [expr int($slidlength/10)]

set timeboxslider1 [scale $cc.6.slider1.start  -font "-size 1" -bg $bg -fg $bg -from $min_validtime -to $maxtime\
					      -length $slidlength \
					      -sliderlength [expr 2*$fs] \
					      -variable tf_start \
					      -orient horizontal \
					      -borderwidth 0 \
					      -troughcolor $sc \
					      -highlightthickness 0 \
					      -tickinterval $sliderincr -showvalue true -resolution 1 \
					      -bigincrement $tickinterval \
					      -command {showTime 1} ]
					      
grid $cc.6.slider1.label -row 0 -column 0 -sticky nw    
grid $cc.6.slider1.start -row 0 -column 1 -sticky w
bind $cc.6.slider1.start <ButtonRelease-1> {adjustTime 1}

# Frame für den Slider Zeitraum und den Rest oben
frame $cc.6.slider2 -bg $bg
grid $cc.6.slider2 -row 2 -column 1 -sticky w
label $cc.6.slider2.label -font "-size $fs" -anchor nw -width $spacer -bg $bg -fg $fg -text $langstring(end,$lang)

set timeboxslider2 [scale $cc.6.slider2.win  -font "-size 1" -bg $bg -fg $bg -from $min_validtime -to $maxtime\
					      -length $slidlength \
					      -sliderlength [expr 2*$fs] \
					      -variable tf_end \
					      -orient horizontal \
					      -borderwidth 0 \
					      -highlightthickness 0 \
					      -troughcolor $sc \
					      -tickinterval $sliderincr -showvalue true -resolution 1 \
					      -bigincrement $tickinterval \
					      -command {showTime 2} ]

grid $cc.6.slider2.label -row 1 -column 0 -sticky nw
grid $cc.6.slider2.win -row 1 -column 1 -sticky w

bind $cc.6.slider2.win <ButtonRelease-1> {adjustTime 2}
}
