# PFotos 1.4 Copyright(C) 2017-2021 Cora Kohlmeier, Frank Hamberg
proc makeSelection {} {
global imagenumber imagecount imgname camera lens focallength focallength35 aperture iso exposure flash imgtype flashanz timeslot
global imgabstime imgdate maxtime mintime mintimedefault max_validtime min_validtime mintime_rem tf_start tf_end  
global alldata csvsep
global binlabels
set counter 0
set flashcounter 0
set filtercounter 0
set imgname ""
set camera ""
set lens "" 
set focallength35 ""
set focallength ""
set aperture ""
set iso ""
set exposure ""
set flash ""
set imgabstime ""
set imgdate ""
set imgtype "" 
set timeslot ""

for {set i 1} {$i <= $imagenumber} {incr i } {
  set line $alldata($i)  
  if {[check_filter $line] && [timeFilter $line] && [dirFilter $line] && [fileFilter $line]} {
    incr counter
	set data [split $line $csvsep]
# Dateiname (mit absolutem Pfad)	
	lappend imgname [lindex $data 0]
# Kameraname
    set cammodel [lindex $data 1]	
	lappend camera $cammodel
	set binlabels(cameras,$cammodel) $cammodel
# Objektivbezeichnung	
	set a [lindex $data 2];
	lappend lens $a
	set binlabels(lenses,$a) $a

# 35mm äquivalente Brennweite	
	set a [lindex $data 3]; 
	lappend focallength35 $a  
# Blende	 
	set a [lindex $data 4]
    lappend aperture $a
# ISO
	set a [lindex $data 5]
	lappend iso $a
# Belichtungszeit (Achtung: kommt als 1/Zahl oder Zahl, wird später ausgerechnet 
	set a [lindex $data 6]
	lappend exposure $a	
# Blitz: Auswertung erfolgt auf "Fired"; Exif bietet ca. 13 Varianten	
	set a [lindex $data 7]
	lappend flash $a
	if {$a=="yes"} { incr flashcounter}
# "physikalische" Brennweite ohne Crop-Faktor	
	set a [lindex $data 8]
    lappend focallength $a
# Datum und Zeit auswerten
# "normales" Datum. Wenn EXIF "-" ergibt wird in readfile 1.1.1970 00:00:00 gesetzt
    lappend imgdate [lindex $data 9]   
# Julianische Zeit
    set a [lindex $data 10]
    lappend imgabstime $a
# Zeitspanne des Datensatzes ermitteln 
# dabei unterscheiden zwischen gültigen Zeitstempeln und den in read_file gesetzten Defaultwerten, falls kein Zeitstempel gefunden wurde 
    if {$a != $mintimedefault} {set min_validtime [min $min_validtime $a]}  
    set mintime [min $mintime $a]
    set mintime_rem $mintime
    set maxtime [max $maxtime $a]
# Bildtyp 
    set a [lindex $data 11]
    lappend imgtype $a
    set binlabels(type,$a) $a
# Stunde des Tages
    set a [lindex $data 12]
    lappend timeslot $a
}
}
set imagecount $counter
set flashanz $flashcounter

#puts "NEW:   mintime:[timetoDate $mintime] maxtime:[timetoDate $maxtime]"
#puts "NEW:   min_validtime:[timetoDate $min_validtime]"
}



