# PFotos 1.4 Copyright(C) 2017-2021 Cora Kohlmeier, Frank Hamberg
proc ReadFile {name} {
global imagenumber
global alldata crc2index
global binlens bincamera bintype bintimeslot
global camera lens imgtype
global filterlist csvsep

global rem_value
#set filterlist ""
set counter 1

if [info exists alldata] {unset alldata}
if [info exist rem_value] {unset rem_value}
# hier muss dafür gesorgt werden, dass alte thumbnails gelöscht werden
#foreach item [split [image names] " "] {
#	if {[string match "thumbnail*" $item ]} {image delete $item}
#}	

set rid [open $name r]
#erste Zeile weg; ist der csv-Header
gets $rid line
set counter 0
while {[gets $rid line]>=0} {
# hier muss ein bisschen gefiltert werden:	
# - Exiftool schreibt bei Auswahl der Option "-csv" als letzte Zeile "SourceFile" in die csv-Datei
# - Das Apple Dateisystem legt gerne Dateien der Form "._<Dateiname> an und Exiftool versucht sich daran, wenn die Extension auf ein Bild deutet
# diese Fälle werden hier gleich verworfen
# - CaptureOne exportiert zu den RAW auch die Verarbeitungsvorschriften. Diese heißen "Bildname.<RAWEXT>.cos" und werden hier auch verworfen. 
# Die Anordnung der Daten ergibt sich aus ../info/exifformat.txt 
  if {![string match "*SourceFile*" $line] && ![string match "*\.\_*" $line] && ![string match "*\.cos*" $line]} {
	incr counter 
	set data [split $line $csvsep]
# Dateiname (mit absolutem Pfad)	
	set imgname [lindex $data 0]
# reverse Liste erzeugen, die dem CRC-Hash den Index $counter zuordnet. 
# Tricky; wird gebraucht für schnelle Erzeugnung der Ballon-Info in showSelection*. crc2index ist dafür global	
	set crc2index([crc::cksum $imgname]) $counter
#Dateityp jpg png CR2 RAF etc
	set imgtype [file extension $imgname]
# Kameraname
    set cammodel [lindex $data 1]
    if {$cammodel=="-"} {set cammodel "unknown"}	
	set camera $cammodel
# Objektivbezeichnung	
	set a [lindex $data 10];
	set a [extractLens $a] 
#### Achtung Versuch wegen Sigma	
# erster Versuch LensModel zu ersetzen --> durch LensID	
	if {$a=="-" || $a=="" || $a=="N/A" || $a=="n/a"} {set a [removeSpace [extractLens [lindex $data 2]]]}
# zweiter Versuch LensID zu ersetzen --> durch LensType	FUNZT NICHT ---- WARUM????? 
#--> Grund: exiftool spuckt auch mal "- " statt nur "-" aus, wenn ein Tag nicht belegt ist
	if {$a=="-" || $a=="" || $a=="N/A" || $a=="n/a"} {set a [removeSpace [extractLens [lindex $data 11]]]}
# und wenn nix hilft, wird das Kameramodel eingetragen	
	if {$a=="-" || $a=="" || $a=="N/A" || $a=="n/a"} {set a $cammodel}
	set lens $a

# Sonderbehandlung 35mm äquivalente Brennweite	
	set a [lindex $data 3]; 
    set a [extract35mmEquiv $a]
    if {$a=="-" || $a==""} {set a "unknown"}
	set focallength35 $a  
# Blende	 
	set a [lindex $data 4]
    if {$a=="-" || $a==""} {set a "unknown"}
    set aperture $a
# ISO
	set a [lindex $data 5]
    if {$a=="-" || $a==""} {set a "unknown"}
    set iso $a
# Belichtungszeit (Achtung: kommt als 1/Zahl oder Zahl, wird später ausgerechnet 
	set a [lindex $data 6]
    if {$a=="-" || $a==""} {set a "unknown"}
	set exposure $a	
# Blitz: Auswertung erfolgt auf "Fired"; Exif bietet ca. 13 Varianten	
	set a [lindex $data 7]
	set a [extractFlash $a]
	set flash $a
# "physikalische" Brennweite ohne Crop-Faktor	
	set a [lindex $data 8]
	set a [extractmm $a]
    if {$a=="-" || $a==""} {set a "unknown"}
    set focallength $a
# Datum-Zeit-Gruppe	
	set a [lindex $data 9]
	regsub -all {\+.} $a "" a
	regsub -all {\-.} $a "" a
	if {$a=="-" || $a==""} {set a "1970:01:01 00:00:00"}
    set datetime $a
    set abstime [absoluteTime $a]
    set hourofday [hourinDate $a]
	set myline "$imgname$csvsep$camera$csvsep$lens$csvsep$focallength35$csvsep$aperture$csvsep$iso$csvsep$exposure$csvsep$flash$csvsep$focallength$csvsep$datetime$csvsep$abstime$csvsep$imgtype$csvsep$hourofday"	
#	set myline "$imgname$csvsep$camera$csvsep$lens$csvsep$focallength35$csvsep$aperture$csvsep$iso$csvsep$exposure$csvsep$flash$csvsep$focallength$csvsep$datetime$csvsep$abstime$csvsep$imgtype"	
# und für die weitere Bearbeitung bereitstellen	
	set alldata($counter) $myline
   }
}
close $rid
set imagenumber [expr $counter-0]

makeSelection

set binlens [lsort -unique -ascii $lens]
set bincamera [lsort -unique -ascii $camera]
set bintype [lsort -unique -ascii $imgtype]
#puts "Readfile: Cameras: $bincamera"
#puts "Readfile: Lenses: $binlens"
}


