# PFotos 1.4 Copyright(C) 2017-2021 Cora Kohlmeier, Frank Hamberg

proc showSelection2 {{item ""}} {
global pfotoshome pfotosrcs pfotosversion iconpath datahome thumbdir exiftool home
global imgname disp_selection warn imagecount cmdstring numthumbcolumns
global DOS
global defaulticonsize
global bg abg fg bfg tf bfs fs dfg gap
global log sel_init finalpos
global langstring lang
global tilebutton thumblist
global startPos MarkAllOn 
global exifoutput exifsavename
if ![info exist MarkAllOn] {set MarkAllOn 0}
# Vorbereitung für den Fensteraufbau
if ![info exist sel_init] { set sel_init 1 }
#Abbruch, wenn zuviele Bilder selektiert sind
if {$sel_init==1} {if {[checkSelection $imagecount] < 0} {return}}

# Jetzt geht es los und das Fenster wird neu aufgebaut, wenn nicht exisitiert. Ansonsten wird aktualisiert
if ![winfo exist .se] {
# Default setzen
if {$item==""} { set item [lindex $imgname 0] }
#puts $item

set logwidth 100
set thumbwidth 160

# Das Textfenster für die Exif-Daten hat bei 10pt 70 Zeilen; die Zahl wird je nach gewähltem Font angepasst
set loglength [expr 70 * 10/$fs]

# die Breite des Buttonframes ergibt sich dann aus butwid bei der für dieses Widget gesetzten font size 10 und der Anzahl der Spalten
if {$DOS==2} {
	set butframewidth [expr 35*$numthumbcolumns]
} else {
	set butframewidth [expr 30*$numthumbcolumns]
}	
# Höhe der Text-Widgets ausgehend von font size 10 und einem brauchbaren Anteil der verfügbaren Bildschirmhöhe
if {$DOS==2} {
	set butframeheight [expr [winfo screenheight .]/18 -2]
} else {
	set butframeheight [expr [winfo screenheight .]/20 -2]
}
# auf finalpos soll das LogWindow --> runlog.tcl positioneren, wenn der Prozess fertig ist 
set finalpos 1.0

toplevel .se -bg $bg
wm geometry .se "+300+30"
wm title .se "Tiger Graphics PFotos -- $langstring(show,$lang)"
wm iconmask .se @$iconpath/tinylogo.pic
wm iconbitmap .se @$iconpath/tinylogo.pic
wm protocol .se WM_DELETE_WINDOW {destroy .se; closeSelection}
wm resizable .se 0 0

frame .se.mid
grid .se.mid -row 0 -column 1 -sticky news
grid rowconfigure .se.mid 0 -weight 0
grid columnconfigure .se.mid 1 -weight 1
# jetzt den Textbereich erzeugen
frame .se.mid.search
grid .se.mid.search -row 1 -column 0 -sticky news
grid rowconfigure .se.mid.search 0 -weight 0

set log [text .se.mid.text -yscrollcommand {.se.mid.scr set} -width $logwidth -height $loglength \
	-borderwidth 0 -relief flat -font "-size $fs" -bg $bg -fg $fg]
scrollbar .se.mid.scr -command {.se.mid.text yview}
grid .se.mid.text .se.mid.scr -sticky news
grid rowconfigure .se.mid.text 1 -weight 1

frame .se.mid.bottom -bg $bg
grid .se.mid.bottom -row 0 -column 0 -sticky news
grid columnconfigure .se.mid.bottom 0 -weight 1
button .se.mid.bottom.save -font "-size $fs" -bg $bg -fg $bfg -text $langstring(saveexif,$lang) -command writeSingleExif
button .se.mid.bottom.open -font "-size $fs" -bg $bg -fg $bfg -text $langstring(gotopath,$lang) -command openPath
pack .se.mid.bottom.save .se.mid.bottom.open -fill x -expand 1 -side left 

 
ExifSearch .se.mid.search .se.mid.text
# rechten Frame für die lange Liste der Auswahlbuttons
frame .se.right -bg $bg
grid .se.right -row 0 -column 2 -sticky news
grid rowconfigure .se.right 0 -weight 0
grid columnconfigure .se.right 2 -weight 1
button .se.right.ok -text $langstring(close,$lang) -bg $bg -fg $bfg -font "-size $fs" -command { closeSelection }
grid .se.right.ok -row 0 -column 0 -sticky news 
button .se.right.tryopen -text $langstring(tryopen,$lang) -bg $bg -fg $bfg -font "-size $fs" -command {updateSelection2 [lindex $imgname 0]}	
grid .se.right.tryopen -row 1 -column 0 -sticky news -pady $gap
frame .se.right.butfr -bg $bg
grid .se.right.butfr -row 2 -column 0 -sticky news
grid rowconfigure .se.right.butfr 2 -weight 0
grid columnconfigure .se.right.butfr 0 -weight 1 

set butfr [text .se.right.butfr.butlist -yscrollcommand {.se.right.butfr.scr set} -width $butframewidth -height $butframeheight \
                 -borderwidth 0 -relief flat -font "-size 10" -bg $bg -fg $fg]
scrollbar .se.right.butfr.scr -command {.se.right.butfr.butlist yview}
grid .se.right.butfr.butlist .se.right.butfr.scr -sticky news 

set thumblist [split [image names] " "]

set col 1
set selbut ""
set k 0
foreach item $imgname {
    set thumbid [crc::cksum $item]
    set butid [file tail $item]
	set search "thumbnail($thumbid)"
	if {[lsearch $thumblist $search] <0} {
	
#################################################
	if {$DOS==1} {
	        set imagefile [file nativename $item]
		    set thumbfile [file nativename $thumbdir/$thumbid.jpg]
	        if {![file exists $thumbfile]} {
				set cmd [file nativename  $pfotoshome/bat/extractthumbnail.bat]
				catch [exec {*}[auto_execok $cmd] $exiftool $imagefile $thumbfile] result
			}	
		} else {	
			set thumbfile $thumbdir/$thumbid.jpg 
			if {![file exists $thumbfile]} { 
				set command "exec $exiftool -b -ThumbnailImage [maskSpace $item] > $thumbfile"
				catch $command result
			}	
	}   
	# alte Bildateien enthalten oft keinen Thumbnail -- dann wird von exiftool .thumb.jpg mit Dateigröße Null erzeugt 
	# und es wird hier ein Thumbnail aus der Originaldatei erzeugt
	if {![file size $thumbfile]} {
	# versuchen wir mal, das Bild selbst einzupassen, wenn es denn eine unterstütze Bilddatei ist
		set cmd "image create photo thumbnail($thumbid) -gamma 1.0 -file [maskSpace $item]"
		catch $cmd result
	# wenn es nicht funktioniert hat, das default-Symbol als Thumbnail aufbereiten und für's nächste Mal ablegen
	# die Fehlermeldung zeichnet sich dadurch, dass der Name der betroffenen Datei vorangestellt ist.... Hoffentlich immer		
	if {[string match "*$item*" $result]} {
		image create photo thumbnail($thumbid) -gamma 1.0 -file $pfotoshome/info/tatze_thumb1.gif }
#		file copy -force $pfotoshome/info/tatze_thumb1.gif $thumbfile
	} else {
	# Normalfall: Thumbnail wurde als jpg extrahiert	
		image create photo thumbnail($thumbid) -gamma 1.0 -file $thumbfile
	}
# und dann in das vorgesehen Fenster einpassen
	set iwidth [image width thumbnail($thumbid)]

    if {$iwidth > $thumbwidth} {
		set scalefactor [expr (1.0*$thumbwidth)/(1.05*$iwidth)] 
		scaleImage thumbnail($thumbid) $scalefactor
    }
  }	    
#################################################

# maximale Buttonbreite bestimmen
	  set tilebutton [button $butfr.$k -text $butid -image thumbnail($thumbid) -compound top\
	          -font "-size $fs" -fg $bfg -bg $bg -command [list updateSelection2 $item;]]
  bind $tilebutton <3> "$tilebutton invoke; .se.right.tryopen invoke"
  bind $tilebutton <Shift-1> "$tilebutton invoke; .se.right.tryopen invoke"
# Balloon Help bzw. Tooltip erzeugen
  set balloon [getBalloon $thumbid]
  DynamicHelp::add $tilebutton -type balloon -text $balloon
# Button in das Text-Widget einbauen
	  $butfr window create end -window $tilebutton	
	  if {[expr fmod($k+1,$numthumbcolumns)]<1.0} { $butfr insert end "\n"}

# Buttons in Liste merken
	   lappend selbut $tilebutton 
	   incr k

}
	# und zum Schluss den aufrufenden Button zum Schließen umkonfigurieren
	$disp_selection configure -fg $warn -text $langstring(close,$lang) -command { closeSelection }
	set item [lindex $imgname 0]
}
#Ab hier wird das vorhandene Selection-Fenster inhaltlich aktualisiert.
checkImage $item

if {$sel_init==1} {
	set sel_init 0
	set cmdstring [lindex $imgname 0]
    .se.right.tryopen configure -command {openAsset $cmdstring};
    setViewer
}
# Fenster im Vordergrund halten
#raise .se
}

proc updateSelection2 {asset} {
global opencommand cmdstring
set cmdstring $asset
#.se.left.imgbut configure -command {openAsset $cmdstring};
showSelection2 $asset
	
}
